%module frida

%rename("%(utitle)s") "";

%include <cpointer.i>
%include <stdint.i>
%include <std_string.i>
%include <std_map.i>
%include <stl.i>

 // noone knows how to get these working
%ignore beginFunctions();
%ignore endFunctions();
%ignore beginBasicBlocks();
%ignore endBasicBlocks();

%{
#include "core/Function.hxx"
#include "core/BasicBlock.hxx"
#include "core/InformationManager.hxx"
#include "disassembler/Disassembler.hxx"

	extern InformationManager* current_information_manager;
%}

namespace std {
	%template(BasicBlockMap) map<unsigned long, BasicBlock*>;
	%template(FunctionMap) map<unsigned long, Function*>;
	%template(InterpreterMap) map<std::string, Interpreter*>;
}

%inline %{
	BasicBlock* deref(BasicBlock** x) {
       return *x;
    }
%}

%include "core/Function.hxx"
%include "core/BasicBlock.hxx"
%include "core/InformationManager.hxx"
%include "disassembler/Disassembler.hxx"

extern InformationManager* current_information_manager;
